blob: 01a179dd0ac5445ae80cc4b28003b61f8e16a568 [file] [log] [blame]
Ollie Lho184a4042005-11-26 21:55:36 +00001#
Uwe Hermannf78cff12009-06-12 14:05:25 +00002# This file is part of the flashrom project.
3#
4# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00005# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
Uwe Hermannf78cff12009-06-12 14:05:25 +00006#
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; version 2 of the License.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
16# You should have received a copy of the GNU General Public License
17# along with this program; if not, write to the Free Software
18# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
Ollie Lho184a4042005-11-26 21:55:36 +000019#
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +000020
Ollie Lho184a4042005-11-26 21:55:36 +000021PROGRAM = flashrom
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +000022
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000023###############################################################################
24# Defaults for the toolchain.
25
26# If you want to cross-compile, just run e.g.
27# make CC=i586-pc-msdosdjgpp-gcc
28# You may have to specify STRIP/AR/RANLIB as well.
Carl-Daniel Hailfingerb7bce8a2012-08-14 21:36:11 +000029#
30# Note for anyone editing this Makefile: gnumake will happily ignore any
31# changes in this Makefile to variables set on the command line.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000032STRIP ?= strip
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000033INSTALL = install
Paul Fox05dfbe62009-06-16 21:08:06 +000034DIFF = diff
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000035PREFIX ?= /usr/local
Uwe Hermann56b2cb02009-05-21 15:59:58 +000036MANDIR ?= $(PREFIX)/share/man
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000037CFLAGS ?= -Os -Wall -Wshadow
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +000038EXPORTDIR ?= .
Patrick Georgi97bc95c2011-03-08 07:17:44 +000039RANLIB ?= ranlib
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000040PKG_CONFIG ?= pkg-config
41BUILD_DETAILS_FILE ?= build_details.txt
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000042
Stefan Taunerfd0d4132012-09-25 21:24:55 +000043# The following parameter changes the default programmer that will be used if there is no -p/--programmer
44# argument given when running flashrom. The predefined setting does not enable any default so that every
45# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
46# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
47# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
48# system attached to an external programmer while the default programmer is set to the internal programmer, and
49# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
50# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
51# values are those specified in enum programmer in programmer.h (which depend on other CONFIG_* options
52# evaluated below, namely those that enable/disable the various programmers).
53# Compilation will fail for unspecified values.
54CONFIG_DEFAULT_PROGRAMMER ?= PROGRAMMER_INVALID
Stefan Tauner265fcac2014-06-02 00:12:23 +000055# The following adds a default parameter for the default programmer set above (only).
56CONFIG_DEFAULT_PROGRAMMER_ARGS ?= ''
57# Example: compiling with
58# make CONFIG_DEFAULT_PROGRAMMER=PROGRAMMER_SERPROG CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
59# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000060
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000061# If your compiler spits out excessive warnings, run make WARNERROR=no
62# You shouldn't have to change this flag.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000063WARNERROR ?= yes
64
65ifeq ($(WARNERROR), yes)
66CFLAGS += -Werror
67endif
68
Stefan Taunere37735a2015-01-26 22:03:35 +000069ifdef LIBS_BASE
Stefan Taunere37735a2015-01-26 22:03:35 +000070PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
Stefan Tauner45207062016-02-19 08:17:24 +000071override CPPFLAGS += -I$(LIBS_BASE)/include
72override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
Stefan Taunere37735a2015-01-26 22:03:35 +000073endif
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000074
Stefan Taunerbfb067b2016-01-07 18:13:07 +000075ifeq ($(CONFIG_STATIC),yes)
Stefan Tauner45207062016-02-19 08:17:24 +000076override PKG_CONFIG += --static
77override LDFLAGS += -static
Stefan Taunerbfb067b2016-01-07 18:13:07 +000078endif
79
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000080# Set LC_ALL=C to minimize influences of the locale.
81# However, this won't work for the majority of relevant commands because they use the $(shell) function and
82# GNU make does not relay variables exported within the makefile to their evironment.
83LC_ALL=C
84export LC_ALL
85
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000086dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000087
88# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
89# in the build details file together with the original stdout output.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000090debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(1) ; }' >&2; { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000091
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000092###############################################################################
Stefan Tauner037cd842013-08-25 00:10:56 +000093# General OS-specific settings.
94# 1. Prepare for later by gathering information about host and target OS
95# 2. Set compiler flags and parameters according to OSes
96# 3. Likewise verify user-supplied CONFIG_* variables.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000097
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +000098# HOST_OS is only used to work around local toolchain issues.
Stefan Tauner037cd842013-08-25 00:10:56 +000099HOST_OS ?= $(shell uname)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000100ifeq ($(HOST_OS), MINGW32_NT-5.1)
101# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
102CC = gcc
103endif
104ifneq ($(HOST_OS), SunOS)
Adam Kaufman064b1f22007-02-06 19:47:50 +0000105STRIP_ARGS = -s
106endif
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000107
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000108# Determine the destination OS.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000109# IMPORTANT: The following line must be placed before TARGET_OS is ever used
110# (of course), but should come after any lines setting CC because the line
111# below uses CC itself.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000112override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000113
114ifeq ($(TARGET_OS), Darwin)
Stefan Tauner45207062016-02-19 08:17:24 +0000115override CPPFLAGS += -I/opt/local/include -I/usr/local/include
116override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauerf79edb92009-01-26 01:23:31 +0000117endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000118
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000119ifeq ($(TARGET_OS), FreeBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000120override CPPFLAGS += -I/usr/local/include
121override LDFLAGS += -L/usr/local/lib
Andriy Gapon65c1b862008-05-22 13:22:45 +0000122endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000123
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000124ifeq ($(TARGET_OS), OpenBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000125override CPPFLAGS += -I/usr/local/include
126override LDFLAGS += -L/usr/local/lib
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000127endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000128
Stefan Taunerc65b8552013-09-12 15:48:39 +0000129ifeq ($(TARGET_OS), NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000130override CPPFLAGS += -I/usr/pkg/include
131override LDFLAGS += -L/usr/pkg/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000132endif
133
134ifeq ($(TARGET_OS), DragonFlyBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000135override CPPFLAGS += -I/usr/local/include
136override LDFLAGS += -L/usr/local/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000137endif
138
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000139ifeq ($(TARGET_OS), DOS)
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000140EXEC_SUFFIX := .exe
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000141# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
Stefan Tauner45207062016-02-19 08:17:24 +0000142override CFLAGS += -Wno-format
Stefan Tauner449abe22013-09-11 23:34:57 +0000143LIBS += -lgetopt
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000144# Bus Pirate, Serprog and PonyProg are not supported under DOS (missing serial support).
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000145ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
146UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
147else
148override CONFIG_BUSPIRATE_SPI = no
149endif
150ifeq ($(CONFIG_SERPROG), yes)
151UNSUPPORTED_FEATURES += CONFIG_SERPROG=yes
152else
153override CONFIG_SERPROG = no
154endif
Stefan Taunerd94d25d2012-07-28 03:17:15 +0000155ifeq ($(CONFIG_PONY_SPI), yes)
156UNSUPPORTED_FEATURES += CONFIG_PONY_SPI=yes
157else
158override CONFIG_PONY_SPI = no
159endif
Urja Rannikko0870b022016-01-31 22:10:29 +0000160# Dediprog, USB-Blaster, PICkit2, CH341A and FT2232 are not supported under DOS (missing USB support).
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000161ifeq ($(CONFIG_DEDIPROG), yes)
162UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
163else
164override CONFIG_DEDIPROG = no
165endif
166ifeq ($(CONFIG_FT2232_SPI), yes)
167UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
168else
169override CONFIG_FT2232_SPI = no
170endif
James Lairdc60de0e2013-03-27 13:00:23 +0000171ifeq ($(CONFIG_USBBLASTER_SPI), yes)
172UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
173else
174override CONFIG_USBBLASTER_SPI = no
175endif
Justin Chevrier66e554b2015-02-08 21:58:10 +0000176ifeq ($(CONFIG_PICKIT2_SPI), yes)
177UNSUPPORTED_FEATURES += CONFIG_PICKIT2_SPI=yes
178else
179override CONFIG_PICKIT2_SPI = no
180endif
Urja Rannikko0870b022016-01-31 22:10:29 +0000181ifeq ($(CONFIG_CH341A_SPI), yes)
182UNSUPPORTED_FEATURES += CONFIG_CH341A_SPI=yes
183else
184override CONFIG_CH341A_SPI = no
185endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000186endif
Ollie Lho184a4042005-11-26 21:55:36 +0000187
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000188# FIXME: Should we check for Cygwin/MSVC as well?
189ifeq ($(TARGET_OS), MinGW)
190EXEC_SUFFIX := .exe
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000191# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000192FLASHROM_CFLAGS += -Dffs=__builtin_ffs
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000193# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
Stefan Tauner23e10b82016-01-23 16:16:49 +0000194# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000195FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000196# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
197ifeq ($(CONFIG_INTERNAL), yes)
198UNSUPPORTED_FEATURES += CONFIG_INTERNAL=yes
199else
200override CONFIG_INTERNAL = no
201endif
202ifeq ($(CONFIG_RAYER_SPI), yes)
203UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
204else
205override CONFIG_RAYER_SPI = no
206endif
207ifeq ($(CONFIG_NIC3COM), yes)
208UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
209else
210override CONFIG_NIC3COM = no
211endif
212ifeq ($(CONFIG_GFXNVIDIA), yes)
213UNSUPPORTED_FEATURES += CONFIG_GFXNVIDIA=yes
214else
215override CONFIG_GFXNVIDIA = no
216endif
217ifeq ($(CONFIG_SATASII), yes)
218UNSUPPORTED_FEATURES += CONFIG_SATASII=yes
219else
220override CONFIG_SATASII = no
221endif
222ifeq ($(CONFIG_ATAHPT), yes)
223UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
224else
225override CONFIG_ATAHPT = no
226endif
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000227ifeq ($(CONFIG_ATAVIA), yes)
228UNSUPPORTED_FEATURES += CONFIG_ATAVIA=yes
229else
230override CONFIG_ATAVIA = no
231endif
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000232ifeq ($(CONFIG_ATAPROMISE), yes)
233UNSUPPORTED_FEATURES += CONFIG_ATAPROMISE=yes
234else
235override CONFIG_ATAPROMISE = no
236endif
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000237ifeq ($(CONFIG_IT8212), yes)
238UNSUPPORTED_FEATURES += CONFIG_IT8212=yes
239else
240override CONFIG_IT8212 = no
241endif
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000242ifeq ($(CONFIG_DRKAISER), yes)
243UNSUPPORTED_FEATURES += CONFIG_DRKAISER=yes
244else
245override CONFIG_DRKAISER = no
246endif
247ifeq ($(CONFIG_NICREALTEK), yes)
248UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
249else
250override CONFIG_NICREALTEK = no
251endif
252ifeq ($(CONFIG_NICNATSEMI), yes)
253UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
254else
255override CONFIG_NICNATSEMI = no
256endif
257ifeq ($(CONFIG_NICINTEL), yes)
258UNSUPPORTED_FEATURES += CONFIG_NICINTEL=yes
259else
260override CONFIG_NICINTEL = no
261endif
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000262ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
263UNSUPPORTED_FEATURES += CONFIG_NICINTEL_EEPROM=yes
264else
265override CONFIG_NICINTEL_EEPROM = no
266endif
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000267ifeq ($(CONFIG_NICINTEL_SPI), yes)
268UNSUPPORTED_FEATURES += CONFIG_NICINTEL_SPI=yes
269else
270override CONFIG_NICINTEL_SPI = no
271endif
272ifeq ($(CONFIG_OGP_SPI), yes)
273UNSUPPORTED_FEATURES += CONFIG_OGP_SPI=yes
274else
275override CONFIG_OGP_SPI = no
276endif
277ifeq ($(CONFIG_SATAMV), yes)
278UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
279else
280override CONFIG_SATAMV = no
281endif
282endif
283
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000284ifeq ($(TARGET_OS), libpayload)
Stefan Tauner8e19b042013-08-28 09:55:04 +0000285ifeq ($(MAKECMDGOALS),)
286.DEFAULT_GOAL := libflashrom.a
287$(info Setting default goal to libflashrom.a)
288endif
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000289FLASHROM_CFLAGS += -DSTANDALONE
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000290ifeq ($(CONFIG_DUMMY), yes)
291UNSUPPORTED_FEATURES += CONFIG_DUMMY=yes
292else
293override CONFIG_DUMMY = no
294endif
Stefan Taunere0168262016-02-21 11:18:24 +0000295# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
296ifeq ($(CONFIG_ATAPROMISE), yes)
297UNSUPPORTED_FEATURES += CONFIG_ATAPROMISE=yes
298else
299override CONFIG_ATAPROMISE = no
300endif
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000301# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000302ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
303UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
304else
305override CONFIG_BUSPIRATE_SPI = no
306endif
307ifeq ($(CONFIG_SERPROG), yes)
308UNSUPPORTED_FEATURES += CONFIG_SERPROG=yes
309else
310override CONFIG_SERPROG = no
311endif
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000312ifeq ($(CONFIG_PONY_SPI), yes)
313UNSUPPORTED_FEATURES += CONFIG_PONY_SPI=yes
314else
315override CONFIG_PONY_SPI = no
316endif
Stefan Tauner0be072c2016-03-13 15:16:30 +0000317# Dediprog, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000318ifeq ($(CONFIG_DEDIPROG), yes)
319UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
320else
321override CONFIG_DEDIPROG = no
322endif
323ifeq ($(CONFIG_FT2232_SPI), yes)
324UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
325else
326override CONFIG_FT2232_SPI = no
327endif
James Lairdc60de0e2013-03-27 13:00:23 +0000328ifeq ($(CONFIG_USBBLASTER_SPI), yes)
329UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
330else
331override CONFIG_USBBLASTER_SPI = no
332endif
Justin Chevrier66e554b2015-02-08 21:58:10 +0000333ifeq ($(CONFIG_PICKIT2_SPI), yes)
334UNSUPPORTED_FEATURES += CONFIG_PICKIT2_SPI=yes
335else
336override CONFIG_PICKIT2_SPI = no
337endif
Urja Rannikko0870b022016-01-31 22:10:29 +0000338ifeq ($(CONFIG_CH341A_SPI), yes)
339UNSUPPORTED_FEATURES += CONFIG_CH341A_SPI=yes
340else
341override CONFIG_CH341A_SPI = no
342endif
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000343endif
344
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000345ifneq ($(TARGET_OS), Linux)
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000346# Android is handled internally as separate OS, but it supports CONFIG_LINUX_SPI and CONFIG_MSTARDDC_SPI
347ifneq ($(TARGET_OS), Android)
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000348ifeq ($(CONFIG_LINUX_SPI), yes)
349UNSUPPORTED_FEATURES += CONFIG_LINUX_SPI=yes
350else
351override CONFIG_LINUX_SPI = no
352endif
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000353ifeq ($(CONFIG_MSTARDDC_SPI), yes)
354UNSUPPORTED_FEATURES += CONFIG_MSTARDDC_SPI=yes
355else
356override CONFIG_MSTARDDC_SPI = no
357endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000358endif
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000359endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000360
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000361ifeq ($(TARGET_OS), Android)
362# Android on x86 (currently) does not provide raw PCI port I/O operations
363ifeq ($(CONFIG_RAYER_SPI), yes)
364UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
365else
366override CONFIG_RAYER_SPI = no
367endif
368endif
369
Stefan Tauner037cd842013-08-25 00:10:56 +0000370###############################################################################
371# General architecture-specific settings.
372# Like above for the OS, below we verify user-supplied options depending on the target architecture.
373
Uwe Hermann44ffd582011-08-20 14:16:00 +0000374# Determine the destination processor architecture.
375# IMPORTANT: The following line must be placed before ARCH is ever used
376# (of course), but should come after any lines setting CC because the line
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000377# below uses CC itself.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000378override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))
Uwe Hermann44ffd582011-08-20 14:16:00 +0000379
Stefan Taunerfb2d77c2015-02-10 08:03:10 +0000380# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
David Hendricksb286da72012-02-13 00:35:35 +0000381# Right now this means the drivers below only work on x86.
382ifneq ($(ARCH), x86)
Uwe Hermann21b10c62011-07-29 12:13:01 +0000383ifeq ($(CONFIG_NIC3COM), yes)
384UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
385else
386override CONFIG_NIC3COM = no
387endif
388ifeq ($(CONFIG_NICREALTEK), yes)
389UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
390else
391override CONFIG_NICREALTEK = no
392endif
393ifeq ($(CONFIG_NICNATSEMI), yes)
394UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
395else
396override CONFIG_NICNATSEMI = no
397endif
398ifeq ($(CONFIG_RAYER_SPI), yes)
399UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
400else
401override CONFIG_RAYER_SPI = no
402endif
403ifeq ($(CONFIG_ATAHPT), yes)
404UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
405else
406override CONFIG_ATAHPT = no
407endif
Carl-Daniel Hailfingerf636ffc2016-02-20 22:04:39 +0000408ifeq ($(CONFIG_ATAPROMISE), yes)
409UNSUPPORTED_FEATURES += CONFIG_ATAPROMISE=yes
410else
411override CONFIG_ATAPROMISE = no
412endif
Uwe Hermann21b10c62011-07-29 12:13:01 +0000413ifeq ($(CONFIG_SATAMV), yes)
414UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
415else
416override CONFIG_SATAMV = no
417endif
418endif
419
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000420# Disable all drivers needing raw access (memory, PCI, port I/O) on
421# architectures with unknown raw access properties.
422# Right now those architectures are alpha hppa m68k sh s390
423ifneq ($(ARCH),$(filter $(ARCH),x86 mips ppc arm sparc))
424ifeq ($(CONFIG_INTERNAL), yes)
425UNSUPPORTED_FEATURES += CONFIG_INTERNAL=yes
426else
427override CONFIG_INTERNAL = no
428endif
429ifeq ($(CONFIG_RAYER_SPI), yes)
430UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
431else
432override CONFIG_RAYER_SPI = no
433endif
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000434ifeq ($(CONFIG_NIC3COM), yes)
435UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
436else
437override CONFIG_NIC3COM = no
438endif
439ifeq ($(CONFIG_GFXNVIDIA), yes)
440UNSUPPORTED_FEATURES += CONFIG_GFXNVIDIA=yes
441else
442override CONFIG_GFXNVIDIA = no
443endif
444ifeq ($(CONFIG_SATASII), yes)
445UNSUPPORTED_FEATURES += CONFIG_SATASII=yes
446else
447override CONFIG_SATASII = no
448endif
449ifeq ($(CONFIG_ATAHPT), yes)
450UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
451else
452override CONFIG_ATAHPT = no
453endif
454ifeq ($(CONFIG_ATAVIA), yes)
455UNSUPPORTED_FEATURES += CONFIG_ATAVIA=yes
456else
457override CONFIG_ATAVIA = no
458endif
459ifeq ($(CONFIG_ATAPROMISE), yes)
460UNSUPPORTED_FEATURES += CONFIG_ATAPROMISE=yes
461else
462override CONFIG_ATAPROMISE = no
463endif
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000464ifeq ($(CONFIG_DRKAISER), yes)
465UNSUPPORTED_FEATURES += CONFIG_DRKAISER=yes
466else
467override CONFIG_DRKAISER = no
468endif
469ifeq ($(CONFIG_NICREALTEK), yes)
470UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
471else
472override CONFIG_NICREALTEK = no
473endif
474ifeq ($(CONFIG_NICNATSEMI), yes)
475UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
476else
477override CONFIG_NICNATSEMI = no
478endif
479ifeq ($(CONFIG_NICINTEL), yes)
480UNSUPPORTED_FEATURES += CONFIG_NICINTEL=yes
481else
482override CONFIG_NICINTEL = no
483endif
484ifeq ($(CONFIG_NICINTEL_SPI), yes)
485UNSUPPORTED_FEATURES += CONFIG_NICINTEL_SPI=yes
486else
487override CONFIG_NICINTEL_SPI = no
488endif
489ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
490UNSUPPORTED_FEATURES += CONFIG_NICINTEL_EEPROM=yes
491else
492override CONFIG_NICINTEL_EEPROM = no
493endif
494ifeq ($(CONFIG_OGP_SPI), yes)
495UNSUPPORTED_FEATURES += CONFIG_OGP_SPI=yes
496else
497override CONFIG_OGP_SPI = no
498endif
499ifeq ($(CONFIG_SATAMV), yes)
500UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
501else
502override CONFIG_SATAMV = no
503endif
504ifeq ($(CONFIG_IT8212), yes)
505UNSUPPORTED_FEATURES += CONFIG_IT8212=yes
506else
507override CONFIG_IT8212 = no
508endif
509endif
510
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000511###############################################################################
512# Flash chip drivers and bus support infrastructure.
513
Stefan Tauner4404f732013-09-12 08:28:56 +0000514CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
Carl-Daniel Hailfingera8cf3622014-08-08 08:33:01 +0000515 sst28sf040.o 82802ab.o \
Stefan Tauner6ee37e22012-12-29 15:03:51 +0000516 sst49lfxxxc.o sst_fwhub.o flashchips.o spi.o spi25.o spi25_statusreg.o \
Aidan Thorntondb4e87d2013-08-27 18:01:53 +0000517 opaque.o sfdp.o en29lv640b.o at45db.o
Sean Nelson5d134642009-12-24 16:54:21 +0000518
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000519###############################################################################
520# Library code.
Sean Nelson5d134642009-12-24 16:54:21 +0000521
Nico Huber18781102012-12-10 13:34:12 +0000522LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o helpers.o
Sean Nelson5d134642009-12-24 16:54:21 +0000523
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000524###############################################################################
525# Frontend related stuff.
Ollie Lho184a4042005-11-26 21:55:36 +0000526
Stefan Tauner9b32de92014-08-08 23:52:33 +0000527CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
Ollie Lho184a4042005-11-26 21:55:36 +0000528
Stefan Taunerec7a35f2013-08-29 00:38:14 +0000529# Set the flashrom version string from the highest revision number of the checked out flashrom files.
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000530# Note to packagers: Any tree exported with "make export" or "make tarball"
531# will not require subversion. The downloadable snapshots are already exported.
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000532SVNVERSION := $(shell ./util/getrevision.sh -u 2>/dev/null )
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000533
Stefan Tauner40ba6fd2016-03-13 17:46:08 +0000534RELEASE := 0.9.9
Stefan Taunerec7a35f2013-08-29 00:38:14 +0000535VERSION := $(RELEASE)-$(SVNVERSION)
Carl-Daniel Hailfinger48e5e092009-08-31 16:25:08 +0000536RELEASENAME ?= $(VERSION)
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000537
538SVNDEF := -D'FLASHROM_VERSION="$(VERSION)"'
Bernhard Walle201bde32008-01-21 15:24:22 +0000539
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000540# Inform user if there is no meaningful version string. If there is version information from a VCS print
541# something anyway because $(info...) will print a line break in any case which would look suspicious.
Stefan Tauner5d1ad352015-01-25 23:57:08 +0000542# The && between the echos is a workaround for old versions of GNU make that issue the error "unterminated
543# variable reference" if a semicolon is used instead.
544$(info $(shell ./util/getrevision.sh -c 2>/dev/null || echo "Files don't seem to be under version control." && \
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000545 echo "Replacing all version templates with $(VERSION)." ))
546
Stefan Tauner037cd842013-08-25 00:10:56 +0000547###############################################################################
548# Default settings of CONFIG_* variables.
549
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000550# Always enable internal/onboard support for now.
551CONFIG_INTERNAL ?= yes
552
Stefan Tauner52b6e9d2013-04-01 00:46:05 +0000553# Always enable serprog for now.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000554CONFIG_SERPROG ?= yes
555
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000556# RayeR SPIPGM hardware support
557CONFIG_RAYER_SPI ?= yes
558
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000559# PonyProg2000 SPI hardware support
560CONFIG_PONY_SPI ?= yes
561
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000562# Always enable 3Com NICs for now.
563CONFIG_NIC3COM ?= yes
564
Carl-Daniel Hailfingerbf3af292010-07-29 14:41:46 +0000565# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
566CONFIG_GFXNVIDIA ?= yes
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000567
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000568# Always enable SiI SATA controllers for now.
569CONFIG_SATASII ?= yes
570
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000571# Highpoint (HPT) ATA/RAID controller support.
572# IMPORTANT: This code is not yet working!
573CONFIG_ATAHPT ?= no
574
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000575# VIA VT6421A LPC memory support
576CONFIG_ATAVIA ?= yes
577
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000578# Promise ATA controller support.
579CONFIG_ATAPROMISE ?= no
580
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000581# Always enable FT2232 SPI dongles for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000582CONFIG_FT2232_SPI ?= yes
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000583
James Lairdc60de0e2013-03-27 13:00:23 +0000584# Always enable Altera USB-Blaster dongles for now.
585CONFIG_USBBLASTER_SPI ?= yes
586
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000587# MSTAR DDC support needs more tests/reviews/cleanups.
588CONFIG_MSTARDDC_SPI ?= no
589
Justin Chevrier66e554b2015-02-08 21:58:10 +0000590# Always enable PICkit2 SPI dongles for now.
591CONFIG_PICKIT2_SPI ?= yes
592
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000593# Always enable dummy tracing for now.
594CONFIG_DUMMY ?= yes
595
596# Always enable Dr. Kaiser for now.
597CONFIG_DRKAISER ?= yes
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000598
Joerg Fischer5665ef32010-05-21 21:54:07 +0000599# Always enable Realtek NICs for now.
600CONFIG_NICREALTEK ?= yes
601
Andrew Morganc29c2e72010-06-07 22:37:54 +0000602# Disable National Semiconductor NICs until support is complete and tested.
603CONFIG_NICNATSEMI ?= no
604
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000605# Always enable Intel NICs for now.
606CONFIG_NICINTEL ?= yes
607
Idwer Vollering004f4b72010-09-03 18:21:21 +0000608# Always enable SPI on Intel NICs for now.
609CONFIG_NICINTEL_SPI ?= yes
610
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000611# Always enable EEPROM on Intel NICs for now.
612CONFIG_NICINTEL_EEPROM ?= yes
613
Mark Marshall90021f22010-12-03 14:48:11 +0000614# Always enable SPI on OGP cards for now.
615CONFIG_OGP_SPI ?= yes
616
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000617# Always enable Bus Pirate SPI for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000618CONFIG_BUSPIRATE_SPI ?= yes
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000619
Simon Glassae616512016-01-23 23:27:58 +0000620# Always enable Dediprog SF100 for now.
621CONFIG_DEDIPROG ?= yes
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000622
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000623# Always enable Marvell SATA controllers for now.
624CONFIG_SATAMV ?= yes
625
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000626# Enable Linux spidev interface by default. We disable it on non-Linux targets.
627CONFIG_LINUX_SPI ?= yes
628
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000629# Always enable ITE IT8212F PATA controllers for now.
630CONFIG_IT8212 ?= yes
631
Urja Rannikko0870b022016-01-31 22:10:29 +0000632# Winchiphead CH341A
633CONFIG_CH341A_SPI ?= yes
634
Carl-Daniel Hailfinger6161ff12009-11-16 21:22:24 +0000635# Disable wiki printing by default. It is only useful if you have wiki access.
Uwe Hermann2db77a02010-06-04 17:07:39 +0000636CONFIG_PRINT_WIKI ?= no
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000637
Stefan Taunerf3503372016-02-26 23:51:21 +0000638# Disable all features if CONFIG_NOTHING=yes is given unless CONFIG_EVERYTHING was also set
639ifeq ($(CONFIG_NOTHING), yes)
640 ifeq ($(CONFIG_EVERYTHING), yes)
641 $(error Setting CONFIG_NOTHING=yes and CONFIG_EVERYTHING=yes does not make sense)
642 endif
643 $(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
644 $(if $(filter yes, $($(var))),\
645 $(eval $(var)=no)))
646endif
647
Patrick Georgiced7ab62015-01-19 19:52:34 +0000648# Enable all features if CONFIG_EVERYTHING=yes is given
649ifeq ($(CONFIG_EVERYTHING), yes)
650$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
651 $(if $(filter no, $($(var))),\
652 $(eval $(var)=yes)))
653endif
654
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000655# Disable feature groups
656ifeq ($(CONFIG_ENABLE_LIBUSB0_PROGRAMMERS), no)
657override CONFIG_PICKIT2_SPI = no
658endif
659ifeq ($(CONFIG_ENABLE_LIBUSB1_PROGRAMMERS), no)
660override CONFIG_CH341A_SPI = no
661override CONFIG_DEDIPROG = no
662endif
663ifeq ($(CONFIG_ENABLE_LIBPCI_PROGRAMMERS), no)
Stefan Tauner0be072c2016-03-13 15:16:30 +0000664override CONFIG_INTERNAL = no
665override CONFIG_NIC3COM = no
666override CONFIG_GFXNVIDIA = no
667override CONFIG_SATASII = no
668override CONFIG_ATAHPT = no
669override CONFIG_ATAVIA = no
670override CONFIG_ATAPROMISE = no
671override CONFIG_IT8212 = no
672override CONFIG_DRKAISER = no
673override CONFIG_NICREALTEK = no
674override CONFIG_NICNATSEMI = no
675override CONFIG_NICINTEL = no
676override CONFIG_NICINTEL_SPI = no
677override CONFIG_NICINTEL_EEPROM = no
678override CONFIG_OGP_SPI = no
679override CONFIG_SATAMV = no
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000680endif
681
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000682# Bitbanging SPI infrastructure, default off unless needed.
683ifeq ($(CONFIG_RAYER_SPI), yes)
684override CONFIG_BITBANG_SPI = yes
685else
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000686ifeq ($(CONFIG_PONY_SPI), yes)
687override CONFIG_BITBANG_SPI = yes
688else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000689ifeq ($(CONFIG_INTERNAL), yes)
690override CONFIG_BITBANG_SPI = yes
691else
692ifeq ($(CONFIG_NICINTEL_SPI), yes)
693override CONFIG_BITBANG_SPI = yes
694else
Mark Marshall90021f22010-12-03 14:48:11 +0000695ifeq ($(CONFIG_OGP_SPI), yes)
696override CONFIG_BITBANG_SPI = yes
697else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000698CONFIG_BITBANG_SPI ?= no
699endif
700endif
701endif
Mark Marshall90021f22010-12-03 14:48:11 +0000702endif
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000703endif
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000704
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000705###############################################################################
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000706# Handle CONFIG_* variables that depend on others set (and verified) above.
707
708# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
709ifeq ($(TARGET_OS), libpayload)
710ifeq ($(CONFIG_INTERNAL), yes)
711ifeq ($(CONFIG_INTERNAL_DMI), no)
712UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
713else
714override CONFIG_INTERNAL_DMI = yes
715endif
716endif
717endif
718
719# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
720CONFIG_INTERNAL_DMI ?= yes
721
722###############################################################################
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000723# Programmer drivers and programmer support infrastructure.
Stefan Tauner037cd842013-08-25 00:10:56 +0000724# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000725
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000726FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER=$(CONFIG_DEFAULT_PROGRAMMER)'
Stefan Tauner265fcac2014-06-02 00:12:23 +0000727FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000728
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000729ifeq ($(CONFIG_INTERNAL), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000730FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000731PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000732ifeq ($(ARCH), x86)
Rudolf Marek70e14592013-07-25 22:58:56 +0000733PROGRAMMER_OBJS += it87spi.o it85spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000734PROGRAMMER_OBJS += ichspi.o ich_descriptors.o dmi.o
735ifeq ($(CONFIG_INTERNAL_DMI), yes)
736FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
737endif
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000738else
739endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000740NEED_LIBPCI += CONFIG_INTERNAL
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000741endif
742
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000743ifeq ($(CONFIG_SERPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000744FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000745PROGRAMMER_OBJS += serprog.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000746NEED_SERIAL += CONFIG_SERPROG
747NEED_POSIX_SOCKETS += CONFIG_SERPROG
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000748endif
749
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000750ifeq ($(CONFIG_RAYER_SPI), yes)
751FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
752PROGRAMMER_OBJS += rayer_spi.o
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000753NEED_RAW_ACCESS += CONFIG_RAYER_SPI
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000754endif
755
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000756ifeq ($(CONFIG_PONY_SPI), yes)
757FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
758PROGRAMMER_OBJS += pony_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000759NEED_SERIAL += CONFIG_PONY_SPI
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000760endif
761
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000762ifeq ($(CONFIG_BITBANG_SPI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000763FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000764PROGRAMMER_OBJS += bitbang_spi.o
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000765endif
766
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000767ifeq ($(CONFIG_NIC3COM), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000768FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000769PROGRAMMER_OBJS += nic3com.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000770NEED_LIBPCI += CONFIG_NIC3COM
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000771endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000772
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000773ifeq ($(CONFIG_GFXNVIDIA), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000774FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000775PROGRAMMER_OBJS += gfxnvidia.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000776NEED_LIBPCI += CONFIG_GFXNVIDIA
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000777endif
778
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000779ifeq ($(CONFIG_SATASII), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000780FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000781PROGRAMMER_OBJS += satasii.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000782NEED_LIBPCI += CONFIG_SATASII
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000783endif
784
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000785ifeq ($(CONFIG_ATAHPT), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000786FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000787PROGRAMMER_OBJS += atahpt.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000788NEED_LIBPCI += CONFIG_ATAHPT
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000789endif
790
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000791ifeq ($(CONFIG_ATAVIA), yes)
792FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
793PROGRAMMER_OBJS += atavia.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000794NEED_LIBPCI += CONFIG_ATAVIA
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000795endif
796
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000797ifeq ($(CONFIG_ATAPROMISE), yes)
798FEATURE_CFLAGS += -D'CONFIG_ATAPROMISE=1'
799PROGRAMMER_OBJS += atapromise.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000800NEED_LIBPCI += CONFIG_ATAPROMISE
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000801endif
802
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000803ifeq ($(CONFIG_IT8212), yes)
804FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
805PROGRAMMER_OBJS += it8212.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000806NEED_LIBPCI += CONFIG_IT8212
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000807endif
808
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000809ifeq ($(CONFIG_FT2232_SPI), yes)
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000810# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000811FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000812NEED_LIBFTDI += CONFIG_FT2232_SPI
James Lairdc60de0e2013-03-27 13:00:23 +0000813PROGRAMMER_OBJS += ft2232_spi.o
814endif
815
816ifeq ($(CONFIG_USBBLASTER_SPI), yes)
817# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000818FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000819NEED_LIBFTDI += CONFIG_USBBLASTER_SPI
James Lairdc60de0e2013-03-27 13:00:23 +0000820PROGRAMMER_OBJS += usbblaster_spi.o
821endif
822
Justin Chevrier66e554b2015-02-08 21:58:10 +0000823ifeq ($(CONFIG_PICKIT2_SPI), yes)
824FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
825PROGRAMMER_OBJS += pickit2_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000826NEED_LIBUSB0 += CONFIG_PICKIT2_SPI
Justin Chevrier66e554b2015-02-08 21:58:10 +0000827endif
828
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000829ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000830FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
831FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
832FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
Alexandru Gagniuc3d06abe2015-12-25 22:42:45 +0000833FEATURE_CFLAGS += $(FTDI_INCLUDES)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000834FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000835# We can't set NEED_LIBUSB0 here because that would transform libftdi auto-enabling
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000836# into a hard requirement for libusb, defeating the purpose of auto-enabling.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000837endif
838
839ifeq ($(CONFIG_DUMMY), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000840FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000841PROGRAMMER_OBJS += dummyflasher.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000842endif
843
844ifeq ($(CONFIG_DRKAISER), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000845FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000846PROGRAMMER_OBJS += drkaiser.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000847NEED_LIBPCI += CONFIG_DRKAISER
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000848endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000849
Joerg Fischer5665ef32010-05-21 21:54:07 +0000850ifeq ($(CONFIG_NICREALTEK), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000851FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
Joerg Fischer5665ef32010-05-21 21:54:07 +0000852PROGRAMMER_OBJS += nicrealtek.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000853NEED_LIBPCI += CONFIG_NICREALTEK
Joerg Fischer5665ef32010-05-21 21:54:07 +0000854endif
855
Andrew Morganc29c2e72010-06-07 22:37:54 +0000856ifeq ($(CONFIG_NICNATSEMI), yes)
857FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
858PROGRAMMER_OBJS += nicnatsemi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000859NEED_LIBPCI += CONFIG_NICNATSEMI
Andrew Morganc29c2e72010-06-07 22:37:54 +0000860endif
861
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000862ifeq ($(CONFIG_NICINTEL), yes)
863FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
864PROGRAMMER_OBJS += nicintel.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000865NEED_LIBPCI += CONFIG_NICINTEL
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000866endif
867
Idwer Vollering004f4b72010-09-03 18:21:21 +0000868ifeq ($(CONFIG_NICINTEL_SPI), yes)
869FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
870PROGRAMMER_OBJS += nicintel_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000871NEED_LIBPCI += CONFIG_NICINTEL_SPI
Idwer Vollering004f4b72010-09-03 18:21:21 +0000872endif
873
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000874ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
875FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
876PROGRAMMER_OBJS += nicintel_eeprom.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000877NEED_LIBPCI += CONFIG_NICINTEL_EEPROM
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000878endif
879
Mark Marshall90021f22010-12-03 14:48:11 +0000880ifeq ($(CONFIG_OGP_SPI), yes)
881FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
882PROGRAMMER_OBJS += ogp_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000883NEED_LIBPCI += CONFIG_OGP_SPI
Mark Marshall90021f22010-12-03 14:48:11 +0000884endif
885
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000886ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
887FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000888PROGRAMMER_OBJS += buspirate_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000889NEED_SERIAL += CONFIG_BUSPIRATE_SPI
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000890endif
891
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000892ifeq ($(CONFIG_DEDIPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000893FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000894PROGRAMMER_OBJS += dediprog.o
Nico Huberd99a2bd2016-02-18 21:42:49 +0000895NEED_LIBUSB1 += CONFIG_DEDIPROG
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000896endif
897
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000898ifeq ($(CONFIG_SATAMV), yes)
899FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
900PROGRAMMER_OBJS += satamv.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000901NEED_LIBPCI += CONFIG_SATAMV
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000902endif
903
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000904ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner8868db32012-03-13 00:18:19 +0000905# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000906FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000907PROGRAMMER_OBJS += linux_spi.o
908endif
909
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000910ifeq ($(CONFIG_MSTARDDC_SPI), yes)
911# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000912FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000913NEED_LINUX_I2C += CONFIG_MSTARDDC_SPI
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000914PROGRAMMER_OBJS += mstarddc_spi.o
915endif
916
Urja Rannikko0870b022016-01-31 22:10:29 +0000917ifeq ($(CONFIG_CH341A_SPI), yes)
918FEATURE_CFLAGS += -D'CONFIG_CH341A_SPI=1'
919PROGRAMMER_OBJS += ch341a_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000920NEED_LIBUSB1 += CONFIG_CH341A_SPI
Urja Rannikko0870b022016-01-31 22:10:29 +0000921endif
922
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000923ifneq ($(NEED_SERIAL), )
Sean Nelson5d134642009-12-24 16:54:21 +0000924LIB_OBJS += serial.o
Carl-Daniel Hailfinger5bdf2982010-06-14 12:42:05 +0000925endif
926
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000927ifneq ($(NEED_POSIX_SOCKETS), )
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000928ifeq ($(TARGET_OS), SunOS)
Stefan Taunerfc3ecc22016-03-13 12:57:03 +0000929LIBS += -lsocket -lnsl
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000930endif
Carl-Daniel Hailfingere51ea102009-11-23 19:20:11 +0000931endif
932
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000933ifneq ($(NEED_LIBPCI), )
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000934CHECK_LIBPCI = yes
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000935# This is a dirty hack, but it saves us from checking all PCI drivers and all platforms manually.
936# libpci may need raw memory, MSR or PCI port I/O on some platforms.
937# Individual drivers might have the same needs as well.
938NEED_RAW_ACCESS += $(NEED_LIBPCI)
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000939FEATURE_CFLAGS += -D'NEED_PCI=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000940FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
Stefan Tauner56734502015-02-08 21:58:04 +0000941
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000942PROGRAMMER_OBJS += pcidev.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000943ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000944# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000945PCILIBS += -lpciutils -lpci
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000946else
947PCILIBS += -lpci
948endif
949endif
950
951ifneq ($(NEED_RAW_ACCESS), )
952# Raw memory, MSR or PCI port I/O access.
953FEATURE_CFLAGS += -D'NEED_RAW_ACCESS=1'
954PROGRAMMER_OBJS += physmap.o hwaccess.o
955
956ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000957# For (i386|x86_64)_iopl(2).
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000958PCILIBS += -l$(shell uname -p)
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000959else
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000960ifeq ($(TARGET_OS), OpenBSD)
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000961# For (i386|amd64)_iopl(2).
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000962PCILIBS += -l$(shell uname -m)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000963else
964ifeq ($(TARGET_OS), Darwin)
965# DirectHW framework can be found in the DirectHW library.
Stefan Taunere34e3e82013-01-01 00:06:51 +0000966PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000967endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000968endif
Jonathan A. Kollasch3646c8f2010-01-08 21:18:08 +0000969endif
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000970
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000971endif
972
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000973ifneq ($(NEED_LIBUSB0), )
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000974CHECK_LIBUSB0 = yes
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000975FEATURE_CFLAGS += -D'NEED_LIBUSB0=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000976USBLIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libusb || printf "%s" "-lusb")
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000977endif
978
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000979ifneq ($(NEED_LIBUSB1), )
Stefan Taunere49edbb82016-01-31 22:10:14 +0000980CHECK_LIBUSB1 = yes
981FEATURE_CFLAGS += -D'NEED_LIBUSB1=1'
982# FreeBSD and DragonflyBSD use a reimplementation of libusb-1.0 that is simply called libusb
983ifeq ($(TARGET_OS),$(filter $(TARGET_OS),FreeBSD DragonFlyBSD))
984USB1LIBS += -lusb
985else
986ifeq ($(TARGET_OS),NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000987override CPPFLAGS += -I/usr/pkg/include/libusb-1.0
Stefan Taunere49edbb82016-01-31 22:10:14 +0000988USB1LIBS += -lusb-1.0
989else
Stefan Tauner45207062016-02-19 08:17:24 +0000990USB1LIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libusb-1.0 || printf "%s" "-lusb-1.0")
991override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libusb-1.0 || printf "%s" "-I/usr/include/libusb-1.0")
Stefan Taunere49edbb82016-01-31 22:10:14 +0000992endif
993endif
994endif
995
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000996ifeq ($(CONFIG_PRINT_WIKI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000997FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000998CLI_OBJS += print_wiki.o
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000999endif
1000
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001001FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
Carl-Daniel Hailfinger132e2ec2010-03-27 16:36:40 +00001002
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +00001003# We could use PULLED_IN_LIBS, but that would be ugly.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001004FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +00001005
Patrick Georgi97bc95c2011-03-08 07:17:44 +00001006LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
Stefan Taunerd94d25d2012-07-28 03:17:15 +00001007OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
Sean Nelson5d134642009-12-24 16:54:21 +00001008
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001009all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001010ifeq ($(ARCH), x86)
1011 @+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
1012endif
1013
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001014$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
Stefan Taunere49edbb82016-01-31 22:10:14 +00001015 $(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS) $(USB1LIBS)
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +00001016
Patrick Georgi97bc95c2011-03-08 07:17:44 +00001017libflashrom.a: $(LIBFLASHROM_OBJS)
1018 $(AR) rcs $@ $^
1019 $(RANLIB) $@
1020
Carl-Daniel Hailfinger8ef7dce2009-07-10 20:19:48 +00001021# TAROPTIONS reduces information leakage from the packager's system.
1022# If other tar programs support command line arguments for setting uid/gid of
1023# stored files, they can be handled here as well.
1024TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001025
Paul Fox05dfbe62009-06-16 21:08:06 +00001026%.o: %.c .features
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +00001027 $(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SVNDEF) -o $@ -c $<
Clark Rawlins02016f72008-02-14 23:22:20 +00001028
Carl-Daniel Hailfingera0020df2010-05-30 22:35:14 +00001029# Make sure to add all names of generated binaries here.
1030# This includes all frontends and libflashrom.
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001031# We don't use EXEC_SUFFIX here because we want to clean everything.
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +00001032clean:
Stefan Tauner4c723152016-01-14 22:47:55 +00001033 rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a *.o *.d $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001034 @+$(MAKE) -C util/ich_descriptors_tool/ clean
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +00001035
Ollie Lho184a4042005-11-26 21:55:36 +00001036distclean: clean
Stefan Reinauere2f01582010-06-07 11:08:07 +00001037 rm -f .features .libdeps
Christian Ruppertdb9d9f42009-05-14 14:17:07 +00001038
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001039strip: $(PROGRAM)$(EXEC_SUFFIX)
1040 $(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +00001041
Stefan Tauner56787082011-08-18 02:27:19 +00001042# to define test programs we use verbatim variables, which get exported
1043# to environment variables and are referenced with $$<varname> later
1044
1045define COMPILER_TEST
1046int main(int argc, char **argv)
1047{
1048 (void) argc;
1049 (void) argv;
1050 return 0;
1051}
1052endef
1053export COMPILER_TEST
1054
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001055compiler: featuresavailable
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001056 @printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001057 @echo "$$COMPILER_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001058 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001059 @{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
1060 echo "found." || { echo "not found."; \
1061 rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001062 @rm -f .test.c .test$(EXEC_SUFFIX)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001063 @printf "Target arch is "
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +00001064 @# FreeBSD wc will output extraneous whitespace.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001065 @echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +00001066 ( echo "unknown. Aborting."; exit 1)
1067 @printf "%s\n" '$(ARCH)'
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001068 @printf "Target OS is "
1069 @# FreeBSD wc will output extraneous whitespace.
1070 @echo $(TARGET_OS)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
1071 ( echo "unknown. Aborting."; exit 1)
1072 @printf "%s\n" '$(TARGET_OS)'
Stefan Taunerd6c17f62013-09-12 14:04:31 +00001073ifeq ($(TARGET_OS), libpayload)
1074 @$(CC) --version 2>&1 | grep -q coreboot || \
1075 ( echo "Warning: It seems you are not using coreboot's reference compiler."; \
1076 echo "This might work but usually does not, please beware." )
1077endif
Carl-Daniel Hailfinger4cb7a962009-06-16 09:31:51 +00001078
Stefan Tauner56787082011-08-18 02:27:19 +00001079define LIBPCI_TEST
1080/* Avoid a failing test due to libpci header symbol shadowing breakage */
1081#define index shadow_workaround_index
Stefan Tauner8d21ff12015-01-10 09:33:06 +00001082#if !defined __NetBSD__
Stefan Tauner56787082011-08-18 02:27:19 +00001083#include <pci/pci.h>
Stefan Taunerc65b8552013-09-12 15:48:39 +00001084#else
1085#include <pciutils/pci.h>
1086#endif
Stefan Tauner56787082011-08-18 02:27:19 +00001087struct pci_access *pacc;
1088int main(int argc, char **argv)
1089{
1090 (void) argc;
1091 (void) argv;
1092 pacc = pci_alloc();
1093 return 0;
1094}
1095endef
1096export LIBPCI_TEST
1097
Stefan Tauner56734502015-02-08 21:58:04 +00001098define PCI_GET_DEV_TEST
1099/* Avoid a failing test due to libpci header symbol shadowing breakage */
1100#define index shadow_workaround_index
1101#if !defined __NetBSD__
1102#include <pci/pci.h>
1103#else
1104#include <pciutils/pci.h>
1105#endif
1106struct pci_access *pacc;
1107struct pci_dev *dev = {0};
1108int main(int argc, char **argv)
1109{
1110 (void) argc;
1111 (void) argv;
1112 pacc = pci_alloc();
1113 dev = pci_get_dev(pacc, dev->domain, dev->bus, dev->dev, 1);
1114 return 0;
1115}
1116endef
1117export PCI_GET_DEV_TEST
1118
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001119define LIBUSB0_TEST
Stefan Tauner0cbd8c22015-01-26 22:06:04 +00001120#include "platform.h"
1121#if IS_WINDOWS
1122#include <lusb0_usb.h>
1123#else
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001124#include <usb.h>
Stefan Tauner0cbd8c22015-01-26 22:06:04 +00001125#endif
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001126int main(int argc, char **argv)
1127{
1128 (void) argc;
1129 (void) argv;
1130 usb_init();
1131 return 0;
1132}
1133endef
1134export LIBUSB0_TEST
1135
Stefan Taunere49edbb82016-01-31 22:10:14 +00001136define LIBUSB1_TEST
1137#include <stddef.h>
1138#include <libusb.h>
1139int main(int argc, char **argv)
1140{
1141 (void)argc;
1142 (void)argv;
1143 libusb_init(NULL);
1144 return 0;
1145}
1146endef
1147export LIBUSB1_TEST
1148
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001149hwlibs: compiler
1150 @printf "" > .libdeps
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001151ifeq ($(CHECK_LIBPCI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001152 @printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001153 @echo "$$LIBPCI_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001154 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001155 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1156 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001157 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001158 echo "Please install libpci headers or disable all features"; \
1159 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +00001160 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001161 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1162 @printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56734502015-02-08 21:58:04 +00001163 @echo "$$PCI_GET_DEV_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001164 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001165 @ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
Stefan Tauner56734502015-02-08 21:58:04 +00001166 ( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001167 ( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1168 @printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001169 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001170 @{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
1171 echo "yes." || { echo "no."; \
1172 printf "Checking if libz+libpci are present and sufficient..." ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001173 { printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz" >>$(BUILD_DETAILS_FILE) ; \
1174 $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001175 echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001176 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001177 echo "Please install libpci (package pciutils) and/or libz or disable all features"; \
1178 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +00001179 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001180 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001181 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001182endif
1183ifeq ($(CHECK_LIBUSB0), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001184 @printf "Checking for libusb-0.1/libusb-compat headers... " | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001185 @echo "$$LIBUSB0_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001186 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001187 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1188 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001189 echo "The following features require libusb-0.1/libusb-compat: $(NEED_LIBUSB0)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001190 echo "Please install libusb-0.1 headers or libusb-compat headers or disable all features"; \
1191 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB0_PROGRAMMERS=no"; \
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001192 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001193 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1194 @printf "Checking if libusb-0.1 is usable... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001195 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USBLIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001196 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USBLIBS) >&2 && \
1197 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001198 echo "The following features require libusb-0.1/libusb-compat: $(NEED_LIBUSB0)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001199 echo "Please install libusb-0.1 or libusb-compat or disable all features"; \
1200 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB0_PROGRAMMERS=no"; \
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001201 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001202 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001203 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +00001204endif
Stefan Taunere49edbb82016-01-31 22:10:14 +00001205ifeq ($(CHECK_LIBUSB1), yes)
1206 @printf "Checking for libusb-1.0 headers... " | tee -a $(BUILD_DETAILS_FILE)
1207 @echo "$$LIBUSB1_TEST" > .test.c
1208 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
1209 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1210 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001211 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001212 echo "Please install libusb-1.0 headers or disable all features"; \
1213 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb82016-01-31 22:10:14 +00001214 echo "See README for more information."; echo; \
1215 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1216 @printf "Checking if libusb-1.0 is usable... " | tee -a $(BUILD_DETAILS_FILE)
1217 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS)" >>$(BUILD_DETAILS_FILE)
1218 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS) >&2 && \
1219 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001220 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001221 echo "Please install libusb-1.0 or disable all features"; \
1222 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb82016-01-31 22:10:14 +00001223 echo "See README for more information."; echo; \
1224 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1225 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
1226endif
Stefan Reinauer53e96252005-12-01 16:19:24 +00001227
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001228.features: features
1229
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001230# If a user does not explicitly request a non-working feature, we should
1231# silently disable it. However, if a non-working (does not compile) feature
1232# is explicitly requested, we should bail out with a descriptive error message.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001233# We also have to check that at least one programmer driver is enabled.
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001234featuresavailable:
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001235ifeq ($(PROGRAMMER_OBJS),)
1236 @echo "You have to enable at least one programmer driver!"
1237 @false
1238endif
1239ifneq ($(UNSUPPORTED_FEATURES), )
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001240 @echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
1241 @false
1242endif
1243
Stefan Tauner56787082011-08-18 02:27:19 +00001244define FTDI_TEST
Stefan Tauner5c316f92015-02-08 21:57:52 +00001245#include <stdlib.h>
Stefan Tauner56787082011-08-18 02:27:19 +00001246#include <ftdi.h>
1247struct ftdi_context *ftdic = NULL;
1248int main(int argc, char **argv)
1249{
1250 (void) argc;
1251 (void) argv;
1252 return ftdi_init(ftdic);
1253}
1254endef
1255export FTDI_TEST
1256
Ilya A. Volynets-Evenbakh2c714ab2012-09-26 00:47:09 +00001257define FTDI_232H_TEST
1258#include <ftdi.h>
1259enum ftdi_chip_type type = TYPE_232H;
1260endef
1261export FTDI_232H_TEST
1262
Stefan Tauner56787082011-08-18 02:27:19 +00001263define UTSNAME_TEST
1264#include <sys/utsname.h>
1265struct utsname osinfo;
1266int main(int argc, char **argv)
1267{
1268 (void) argc;
1269 (void) argv;
1270 uname (&osinfo);
1271 return 0;
1272}
1273endef
1274export UTSNAME_TEST
1275
Stefan Tauner8868db32012-03-13 00:18:19 +00001276define LINUX_SPI_TEST
1277#include <linux/types.h>
1278#include <linux/spi/spidev.h>
1279
1280int main(int argc, char **argv)
1281{
1282 (void) argc;
1283 (void) argv;
1284 return 0;
1285}
1286endef
1287export LINUX_SPI_TEST
1288
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001289define LINUX_I2C_TEST
1290#include <linux/i2c-dev.h>
1291#include <linux/i2c.h>
1292
1293int main(int argc, char **argv)
1294{
1295 (void) argc;
1296 (void) argv;
1297 return 0;
1298}
1299endef
1300export LINUX_I2C_TEST
1301
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001302features: compiler
1303 @echo "FEATURES := yes" > .features.tmp
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001304ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001305 @printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001306 @echo "$$FTDI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001307 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001308 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1309 ( echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
1310 printf "Checking for FT232H support in libftdi... " ; \
1311 echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001312 printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE) ; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001313 { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1314 ( echo "found."; echo "FT232H := yes" >> .features.tmp ) || \
1315 ( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
1316 ) || \
1317 ( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
1318 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +00001319endif
Stefan Tauner8868db32012-03-13 00:18:19 +00001320ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001321 @printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001322 @echo "$$LINUX_SPI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001323 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001324 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner8868db32012-03-13 00:18:19 +00001325 ( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001326 ( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
1327 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001328endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001329ifneq ($(NEED_LINUX_I2C), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001330 @printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001331 @echo "$$LINUX_I2C_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001332 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001333 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001334 ( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001335 ( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
1336 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001337endif
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001338 @printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001339 @echo "$$UTSNAME_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001340 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001341 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner56787082011-08-18 02:27:19 +00001342 ( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001343 ( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001344 @$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1345 @rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
Paul Fox05dfbe62009-06-16 21:08:06 +00001346
Stefan Tauner4c723152016-01-14 22:47:55 +00001347$(PROGRAM).8.html: $(PROGRAM).8
1348 @groff -mandoc -Thtml $< >$@
1349
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001350$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner4c723152016-01-14 22:47:55 +00001351 @# Add the man page change date and version to the man page
1352 @sed -e 's#.TH FLASHROM 8 ".*".*#.TH FLASHROM 8 "$(shell ./util/getrevision.sh -d $(PROGRAM).8.tmpl 2>/dev/null)" "$(VERSION)"#' <$< >$@
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001353
1354install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Uwe Hermannc2a9c9c2009-05-14 14:51:14 +00001355 mkdir -p $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001356 mkdir -p $(DESTDIR)$(MANDIR)/man8
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001357 $(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001358 $(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
Uwe Hermannc113b572006-12-14 00:59:41 +00001359
Nico Huber454f6132012-12-10 13:34:10 +00001360libinstall: libflashrom.a libflashrom.h
1361 mkdir -p $(DESTDIR)$(PREFIX)/lib
1362 $(INSTALL) -m 0644 libflashrom.a $(DESTDIR)$(PREFIX)/lib
1363 mkdir -p $(DESTDIR)$(PREFIX)/include
1364 $(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
1365
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001366export: $(PROGRAM).8
Carl-Daniel Hailfinger48e5e092009-08-31 16:25:08 +00001367 @rm -rf $(EXPORTDIR)/flashrom-$(RELEASENAME)
1368 @svn export -r BASE . $(EXPORTDIR)/flashrom-$(RELEASENAME)
1369 @sed "s/^SVNVERSION.*/SVNVERSION := $(SVNVERSION)/" Makefile >$(EXPORTDIR)/flashrom-$(RELEASENAME)/Makefile
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001370 @cp $(PROGRAM).8 "$(EXPORTDIR)/flashrom-$(RELEASENAME)/$(PROGRAM).8"
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +00001371 @svn log >$(EXPORTDIR)/flashrom-$(RELEASENAME)/ChangeLog
Carl-Daniel Hailfinger48e5e092009-08-31 16:25:08 +00001372 @echo Exported $(EXPORTDIR)/flashrom-$(RELEASENAME)/
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001373
1374tarball: export
Carl-Daniel Hailfinger48e5e092009-08-31 16:25:08 +00001375 @tar cjf $(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2 -C $(EXPORTDIR)/ $(TAROPTIONS) flashrom-$(RELEASENAME)/
1376 @rm -rf $(EXPORTDIR)/flashrom-$(RELEASENAME)
1377 @echo Created $(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001378
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001379djgpp-dos: clean
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001380 make CC=i586-pc-msdosdjgpp-gcc STRIP=i586-pc-msdosdjgpp-strip
1381libpayload: clean
1382 make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001383
Stefan Tauner74dc73f2015-03-01 22:04:38 +00001384.PHONY: all install clean distclean compiler hwlibs features export tarball djgpp-dos featuresavailable libpayload
Ollie Lho184a4042005-11-26 21:55:36 +00001385
Stefan Tauner23e10b82016-01-23 16:16:49 +00001386# Disable implicit suffixes and built-in rules (for performance and profit)
1387.SUFFIXES:
1388
Stefan Reinauere2f01582010-06-07 11:08:07 +00001389-include $(OBJS:.o=.d)